﻿using System;
using System.Diagnostics.Contracts;

namespace CodeContracts_InterfaceContracts
{
    class Program
    {
        static void Main( string[] args )
        {
            var hourlyPayrollCalculator = new HourlyPayrollCalculator();
            var salaryPayrollCalculator = new SalaryPayrollCalculator();

            var hourlyBaseRate = hourlyPayrollCalculator.DetermineBaseRate( EmployeeType.NineToFiver );
            var hourlyPaycheck = hourlyPayrollCalculator.CalculatePaycheck( -4, 45 );

            var salaryBaseRate = salaryPayrollCalculator.DetermineBaseRate( EmployeeType.OverAchiever );
            var salaryPaycheck = salaryPayrollCalculator.CalculatePaycheck( hourlyBaseRate, 55 );
        }
    }

    public enum EmployeeType
    {
        LazyJoe,
        NineToFiver,
        GoGetter,
        OverAchiever
    }
}
